/**
 * 
 * Manipulating the DOM exercise.
 * Exercise programmatically builds navigation,
 * scrolls to anchors from navigation,
 * and highlights section in viewport upon scrolling.
 * 
 * Dependencies: None
 * 
 * JS Version: ES2015/ES6
 * 
 * JS Standard: ESlint
 * 
*/

/**
 * Define Global Variables
 * 
*/
var items = ["section1", "section2", "section3", "section4"];
var ul = document.getElementById('navbar__list');

/**
 * End Global Variables
*/


// Build menu 
for(var i=0; i<items.length; i++){ 
var list = document.createElement('li');
ul.appendChild(list);
var anchor = document.createElement('a');
var linkText = document.createTextNode(items[i]);
anchor.appendChild(linkText);

// Scroll to section on link click

anchor.href = "#"+items[i]+""
anchor.classList.add('menu__link');
list.appendChild(anchor);


// Set sections as active

list.addEventListener('click',function(){
    this.classList.add('active');
    for (let sibling of this.parentNode.children) {
        if (sibling !== this)
         sibling.classList.remove('active');
    }
})

};

function isInViewport(el) {
    const rect = el.getBoundingClientRect();
    return (
        rect.top >= 0 &&
        rect.left >= 0 &&
        rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
        rect.right <= (window.innerWidth || document.documentElement.clientWidth)

    );

 }


var sections = document.getElementsByTagName('section'),
 li = document.getElementsByTagName('li');

 window.addEventListener ('scroll' ,function() {
     for (var i=0; i<sections.length; i++){
         if (isInViewport(sections[i])){
            li[i].classList.add('active')
         } else {
            li[i].classList.remove('active')
         }
     }}
     )
 


 









